// FFT.c    t[Gϊ@FFT

#include "HU.h"

void FFT2D( float x[] , float y[] , int data_n , int invert )
{
	// Numerical Recipes in C (p440-442) p (ꕔύX)B
	
	// invert  1 Ȃ΁A摜 x Qt[Gϊ
	// ʂ  x ,  y ̔zɓB
	// data_n ́A摜̈ӂ̉fiQ̊K̕KvjB

	// invert  -1 Ȃ΁A x ,  y 
	// Qtt[GϊāAʂ 摜 x ̔zɓB
	
	int		i,idim,i1,i2,i3,i2rev,i3rev,ip1,ip2,ip3,ifp1,ifp2;
	int		ibit,k1,k2,n,nprev,nrem,dimension;
	float	tempi,tempr,temp;
	double	theta,wi,wpi,wpr,wr,wtemp, PI = 3.141592653589793; 
	float	*data;

	data = calloc( (data_n+1)*(data_n+1) * 2, sizeof(float) );

	dimension = 2;	
	
	for (i=1; i<=data_n * data_n ; i++ ){
	
		data[2*i-1]=x[i];   data[2*i]=y[i];
	}

	nprev=1;
	
	for(idim=dimension; idim>=1; idim--){ Event();

		n = data_n;
		nrem = data_n * data_n / (n*nprev) ;

		ip1 = nprev << 1;
		ip2 = ip1 * n;
		ip3 = ip2 * nrem;
		i2rev = 1;

		for(i2=1; i2<=ip2; i2+=ip1){
		
			if(i2 < i2rev){
			
				for( i1=i2; i1<=i2+ip1-2; i1+=2 ){
				
					for( i3 =i1; i3 <= ip3; i3 += ip2 ){
					
						i3rev = i2rev +i3 -i2;      

						temp=data[i3]; data[i3]=data[i3rev]; data[i3rev]=temp;                
						temp=data[i3+1]; data[i3+1]=data[i3rev+1]; data[i3rev+1]=temp;
					}
				}
			}
			
			ibit = ip2 >> 1;

			while( ibit >=ip1 && i2rev > ibit ){
			
				i2rev -= ibit;
				ibit >>= 1;
			}
			
			i2rev += ibit;
		}
	
		ifp1 = ip1 ;

		while( ifp1 < ip2){
		
			ifp2 = ifp1 << 1;
			theta = invert * 2. * PI / (ifp2 / ip1); 
			wtemp = sin(0.5*theta);
			wpr = -2.0 * wtemp * wtemp;
			wpi = sin(theta);
			wr = 1.0; wi = 0.0;

		// Danielson-Lanczos  FFT ASY

			for( i3=1; i3<=ifp1; i3+=ip1 ){
			
				for( i1=i3; i1<=i3+ip1-2; i1+=2 ){

					for( i2=i1; i2<=ip3; i2+=ifp2){
					
						k1 = i2;
						k2 = k1+ifp1;
						tempr = (float)wr*data[k2]-(float)wi*data[k2+1];
						tempi = (float)wr*data[k2+1]+(float)wi*data[k2];
						data[k2] = data[k1]-tempr;
						data[k2+1] = data[k1+1]-tempi;
						data[k1] += tempr;
						data[k1+1] += tempi;
					}
				}
				
				wr = (wtemp=wr)*wpr-wi*wpi+wr;
				wi = wi*wpr+wtemp*wpi+wi;
			}
			
			ifp1 = ifp2;
		}

		nprev *= n;
	}

	for (i = 1; i <= data_n * data_n ; i++ ){ 
	
		if(invert ==  1){ x[i] = data[2*i-1];  y[i] = data[2*i]; }
		if(invert == -1){ x[i] = data[2*i-1]/(data_n*data_n);  y[i] = data[2*i]/(data_n*data_n); }
	}
	
	free(data);
}



void Main(void)
{
	char		a,b,yn, f[100];
	int			i, j, count, maxcount, count2, ip, jp, ip2, jp2; 
	static int	img[260][260]; 
    	
	static float x[66000], y[66000], imgFFT[260][260], imgIFFT[260][260], g[260][260];
 	
	float  maxcountFFT, countFFT, maxcountIFFT, countIFFT;

	FILE *fp;
	
	TextWindow(10,10,300,500); Title("Image FFT");
	GraphicWindow(800,600,BK_BLACK);	
	
 START: printf("\n Select Display Image \n"); ClearWindow();
	
//------------------ Get image data ------------------

	GetFileName(f,0); 	printf("\n Display image = \n\n  %s", f); 	fp=fopen(f,"rb");

	for(j=1;j<=256;j++){for(i=1;i<=256;i++){ 

	        a = fgetc(fp);  b = fgetc(fp);
        	     	 	
			img[i][j] = a * 256 + b;
	}}
	fclose(fp);

//----------------- Get Max count --------------------
    maxcount =0 ;
    
	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){

	    if(img[i][j] > maxcount) maxcount = img[i][j];
	}} 
   
	printf("\n\n Original max count = %d ", maxcount);
	
//------------------ Display image ---------------------
	
	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){

	    count = img[i][j];

		count *= 255 / maxcount; 
	   
 			if(count < 0   ) count = 0  ; 
			if(count > 255 ) count = 255;

		SetColor( RGB(count, count, count) );  SetPixel(i,j);
   }}

	printf("\n\n Perform FFT (OK: enter) ");scanf("%c",&yn);

//------------------- FFT -------------------------------

	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){

	    x[i+256*(j-1)] = (float)img[i][j];  y[i+256*(j-1)] = 0.0;
	}}

 
	FFT2D(x,y,256,1);

	
	for(j=0;j<=255;j++){ for(i=1;i<=256;i++){

	    imgFFT[i][j+1] = sqrt( x[i+256*j] * x[i+256*j] + y[i+256*j] * y[i+256*j]);

	}}


//----------------- Get FFT Max count --------------------
  maxcountFFT =0.0 ;
    
	for(j=15;j<=128;j++){ for(i=15;i<=128;i++){

	    if(imgFFT[i][j] > maxcountFFT) maxcountFFT = imgFFT[i][j];
	}} 
   
	printf("\n\n FFT max count = %.2lf ", maxcountFFT);

//------------------ Display FFT sin component --------------
	
	for(j=1;j<=128;j++){ for(i=1;i<=128;i++){ 
		
		g[i][j] = x[(129-i)+(129-j)*256]; 
		g[i+128][j] = x[(257-i)+(129-j)*256];
		g[i][j+128] = x[(129-i)+(257-j)*256];
		g[i+128][j+128] = x[(257-i)+(257-j)*256];
	}}

	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){ 

	    countFFT = g[i][j] + maxcountFFT/2.0; 

		countFFT *= (255. / maxcountFFT/2.0);   count = (int)countFFT;
	   
 			if(count < 0   ) count = 0  ; 
			if(count > 255 ) count = 255;

		SetColor( RGB(count, count, count) );  	SetPixel(i+260,j);
   }}
//------------------ Display FFT cos component --------------

	for(j=1;j<=128;j++){ for(i=1;i<=128;i++){ 
		
		g[i][j] = y[(129-i)+(129-j)*256]; 
		g[i+128][j] = y[(257-i)+(129-j)*256];
		g[i][j+128] = y[(129-i)+(257-j)*256];
		g[i+128][j+128] = y[(257-i)+(257-j)*256];
	}}

	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){ 

	    countFFT = g[i][j] + maxcountFFT/2.0; 

		countFFT *= (255. / maxcountFFT/2.0);   count = (int)countFFT;
	   
 			if(count < 0   ) count = 0  ; 
			if(count > 255 ) count = 255;

		SetColor( RGB(count, count, count) ); 	SetPixel(i+520,j);
   }}
	
//------------------ Display FFT image ---------------------
	
	printf("\n\n Display FFT spectrum (OK: enter) ");scanf("%c",&yn);

	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){ 

	    countFFT = imgFFT[i][j]; 

		countFFT *= (255. / maxcountFFT);   count = (int)countFFT;
	   
 			if(count < 0   ) count = 0  ; 
			if(count > 255 ) count = 255;

		SetColor( RGB(count, count, count) ); 
			
		SetPixel(i+260,j);
   }}

//------------------ Display FFT spectrum  --------------

	for(j=1;j<=128;j++){ for(i=1;i<=128;i++){ 
		
		g[i][j] = imgFFT[129-i][129-j]; 
		g[i+128][j] = imgFFT[257-i][129-j];
		g[i][j+128] = imgFFT[129-i][257-j];
		g[i+128][j+128] = imgFFT[257-i][257-j];
	}}

	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){ 

	    countFFT = g[i][j]; 

		countFFT *= (255. / maxcountFFT);   count = (int)countFFT;
	   
 			if(count < 0) count=0;  if(count > 255) count=255;

		SetColor( RGB(count, count, count) ); 	SetPixel(i+520,j);

   }}
//------------------ Display FFT spctrum curve --------------
	
	for(j=50;j<=200;j++){ for(i=50;i<=200;i++){ 

	    countFFT = g[i][j]  *(255./maxcountFFT); count = (int)countFFT;
		countFFT = g[i+1][j]*(255./maxcountFFT); count2= (int)countFFT;
		
		ip = 400 + i + j;               ip2 = 400 + i+1 + j;
		
		jp = 550 - count/200 -i/2 ;     jp2 = 550 - count2/200 -(i+1)/2 ; 

		SetColor(RGB(i,j,255)); Line(ip,jp, ip2,jp2);
   }}

//------------------- IFFT -------------------------------

	printf("\n\n Perform IFFT (OK: enter) ");scanf("%c",&yn);


	FFT2D(x,y,256,-1);

	
	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){

	    imgIFFT[i][j] = x[i+256*(j-1)];
	}}

//----------------- Get FFT Max count --------------------
  maxcountIFFT =0.0 ;
    
	for(j=20;j<=236;j++){ for(i=20;i<=236;i++){

	    if(imgIFFT[i][j] > maxcountIFFT) maxcountIFFT = imgIFFT[i][j];
	}} 
   
	printf("\n\n IFFT max count = %lf ", maxcountIFFT);

//------------------ Display IFFT image ---------------------
	
	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){ 

	    countIFFT = imgIFFT[i][j]; 

		countIFFT *= (255. / maxcountIFFT);   count = (int)countIFFT;
	   
 			if(count < 0   ) count = 0  ; 
			if(count > 255 ) count = 255;

		SetColor( RGB(count, count, count) ); SetPixel(i,j+300);
   }}

//------------------- End -------------------------------
	
	printf("\n\n Retry? (no:n) ");scanf("%c",&yn); if(yn!='n')goto START;

	exit(0);
}
